#ifndef KHEAP_H
#define KHEAP_H

#include "os.h"

/*
#define KHEAP_START         0x60000000
#define KHEAP_INITIAL_SIZE  0x100000
*/

#define HEAP_INDEX_SIZE     0x20000
#define HEAP_MAGIC          0x123890AB
#define HEAP_MIN_SIZE       0x70000

ULONG end               = 0x400000;    // 4 MB TODO???
ULONG placement_address = (ULONG)&end;

typedef struct
{
    ULONG magic;   // Magic number, used for error checking and identification.
    UCHAR is_hole;   // 1 if this is a hole. 0 if this is a block.
    ULONG size;    // size of the block, including the end footer.
} header_t;

typedef struct
{
    ULONG magic;     // Magic number, same as in header_t.
    header_t *header; // Pointer to the block header.
} footer_t;

heap_t* create_heap(ULONG start, ULONG end, ULONG max, UCHAR supervisor, UCHAR readonly);

void* alloc(ULONG size, UCHAR page_align, heap_t *heap);
void free(void* p, heap_t* heap);

ULONG kmalloc_int(ULONG sz, int align, ULONG* phys);
ULONG kmalloc_a(ULONG sz);
ULONG kmalloc_p(ULONG sz, ULONG* phys);
ULONG kmalloc_ap(ULONG sz, ULONG* phys);
ULONG kmalloc(ULONG sz);

void kfree(void* p);

heap_t* kheap = 0;

#endif
